package org.openprivacy.reptile.om;

// JDK classes
import java.util.*;
import java.math.*;
import java.sql.*;

// Village classes
import com.workingdogs.village.*;

// Turbine classes
import org.apache.turbine.om.*;
import org.apache.turbine.om.peer.*;
import org.apache.turbine.util.*;
import org.apache.turbine.util.db.*;
import org.apache.turbine.util.db.map.*;
import org.apache.turbine.util.db.pool.DBConnection;
import org.apache.turbine.services.db.TurbineDB;

// Local classes
import org.openprivacy.reptile.om.map.*;

/**
  * This class was autogenerated by Torque on:
  *
  * [Mon Jul 01 17:54:11 PDT 2002]
  *
  */
public abstract class BaseWeblogPeer 
    extends BasePeer
{

    /** the mapbuilder for this class */
    private static final WeblogMapBuilder mapBuilder = 
        (WeblogMapBuilder)getMapBuilder(WeblogMapBuilder.CLASS_NAME);

    /** the table name for this class */
    public static final String TABLE_NAME = mapBuilder.getTable();

    /** 
     * @returns the map builder for this peer 
     */
    public static MapBuilder getMapBuilder()
    {
       return(mapBuilder);
    }

    /** the column name for the ID field */
    public static final String ID = mapBuilder.getWeblog_Id();
    /** the column name for the LOCATION field */
    public static final String LOCATION = mapBuilder.getWeblog_Location();
    /** the column name for the TITLE field */
    public static final String TITLE = mapBuilder.getWeblog_Title();
    /** the column name for the DESCRIPTION field */
    public static final String DESCRIPTION = mapBuilder.getWeblog_Description();
    /** the column name for the COMMENTS field */
    public static final String COMMENTS = mapBuilder.getWeblog_Comments();
    /** the column name for the DC_SUBJECT field */
    public static final String DC_SUBJECT = mapBuilder.getWeblog_DcSubject();
    /** the column name for the DATE_FOUND field */
    public static final String DATE_FOUND = mapBuilder.getWeblog_DateFound();
    /** the column name for the LAST_UPDATED field */
    public static final String LAST_UPDATED = mapBuilder.getWeblog_LastUpdated();

 
    /** number of columns for this peer */
    public static final int numColumns =  8;

    /** A class that can be returned by this peer. */
    protected static final String CLASSNAME_DEFAULT = 
        "org.openprivacy.reptile.om.Weblog";

    /** A class that can be returned by this peer. */
    protected static final Class CLASS_DEFAULT = initClass();

    /** Initialization method for static CLASS_DEFAULT attribute */
    private static Class initClass()
    {
        Class c = null;
        try
        { 
            c = Class.forName(CLASSNAME_DEFAULT);
        }
        catch (Exception e)
        {
            Log.error("A FATAL ERROR has occurred which should not" +
                "have happened under any circumstance.  Please notify" +
                "Turbine and give as many details as possible including the " +
                "error stacktrace.", e);
        }
        return c;
    }


    /**
     * Get the list of objects for a ResultSet.  Please not that your
     * resultset MUST return columns in the right order.  You can use
     * getFieldNames() in BaseObject to get the correct sequence.
     */
    public static Vector resultSet2Objects (java.sql.ResultSet results) throws Exception
    {
        QueryDataSet qds = null;
        Vector rows = null;
        try
        {
            qds = new QueryDataSet( results );
            rows = getSelectResults( qds );
        }
        finally
        {
            if (qds != null) qds.close();
        }

        return populateObjects (rows);

    }



    /** Method to do inserts */
    public static ObjectKey doInsert( Criteria criteria ) throws Exception
    {
            criteria.setDbName(mapBuilder.getDatabaseMap().getName());
                                                                                                                                 return BasePeer.doInsert( criteria );
    }

    /** 
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.  It will take care of 
     * the connection details internally. 
     */
    public static ObjectKey doInsert( Criteria criteria, DBConnection dbCon ) 
        throws Exception
    {
            criteria.setDbName(mapBuilder.getDatabaseMap().getName());
                                                                                                                                 return BasePeer.doInsert( criteria, dbCon );
    }

    /** Add all the columns needed to create a new object */
    public static void addSelectColumns (Criteria criteria) throws Exception
    {
            criteria.addSelectColumn( ID );
            criteria.addSelectColumn( LOCATION );
            criteria.addSelectColumn( TITLE );
            criteria.addSelectColumn( DESCRIPTION );
            criteria.addSelectColumn( COMMENTS );
            criteria.addSelectColumn( DC_SUBJECT );
            criteria.addSelectColumn( DATE_FOUND );
            criteria.addSelectColumn( LAST_UPDATED );
        }


    /** 
     * Create a new object of type cls from a resultset row starting
     * from a specified offset.  This is done so that you can select
     * other rows than just those needed for this object.  You may
     * for example want to create two objects from the same row.
     */
    public static Weblog row2Object (Record row, 
                                              int offset, 
                                              Class cls ) 
        throws Exception
    {
        Weblog obj = (Weblog)cls.newInstance();
        populateObject(row, offset, obj);
                    obj.setModified(false);
                obj.setNew(false);

        return obj;
    }

    /** 
     * Populates an object from a resultset row starting
     * from a specified offset.  This is done so that you can select
     * other rows than just those needed for this object.  You may
     * for example want to create two objects from the same row.
     */
    public static void populateObject (Record row, 
                                       int offset, 
                                       Weblog obj ) 
        throws Exception
    {
                                                        obj.setId(
                new NumberKey(row.getValue(offset+0).asBigDecimal()));
                                                                            obj.setLocation(row.getValue(offset+1).asString());
                                                                            obj.setTitle(row.getValue(offset+2).asString());
                                                                            obj.setDescription(row.getValue(offset+3).asString());
                                                                            obj.setComments(row.getValue(offset+4).asString());
                                                                            obj.setDcSubject(row.getValue(offset+5).asString());
                                                                            obj.setDateFound(row.getValue(offset+6).asLong());
                                                                            obj.setLastUpdated(row.getValue(offset+7).asLong());
                                        }

    /** Method to do selects */
    public static Vector doSelect( Criteria criteria ) throws Exception
    {
        return populateObjects( doSelectVillageRecords(criteria) ); 
    }


    /** Method to do selects within a transaction */
    public static Vector doSelect( Criteria criteria, 
                                   DBConnection dbCon ) 
        throws Exception
    {
        return populateObjects( doSelectVillageRecords(criteria, dbCon) ); 
    }

    /** 
     * Grabs the raw Village records to be formed into objects.
     * This method handles connections internally.  The Record objects
     * returned by this method should be considered readonly.  Do not
     * alter the data and call save(), your results may vary, but are
     * certainly likely to result in hard to track MT bugs.
     */
    public static Vector doSelectVillageRecords( Criteria criteria ) 
        throws Exception
    {
            criteria.setDbName(mapBuilder.getDatabaseMap().getName());
            if (criteria.getSelectColumns().size() == 0)
        {
            addSelectColumns ( criteria );
        }

                                                                                                                     
        // BasePeer returns a Vector of Value (Village) arrays.  The array
        // order follows the order columns were placed in the Select clause.
        return BasePeer.doSelect(criteria);
    }


    /** 
     * Grabs the raw Village records to be formed into objects.
     * This method should be used for transactions 
     */
    public static Vector doSelectVillageRecords( Criteria criteria, 
                                                 DBConnection dbCon ) 
        throws Exception
    {
        if (criteria.getSelectColumns().size() == 0)
        {
            addSelectColumns ( criteria );
        }

                                                                                                                     
        // BasePeer returns a Vector of Value (Village) arrays.  The array
        // order follows the order columns were placed in the Select clause.
        return BasePeer.doSelect(criteria, dbCon);
    }

    /** 
     * The returned vector will contain objects of the default type or
     * objects that inherit from the default.
     */
    public static Vector populateObjects(Vector records) 
        throws Exception
    {
        Vector results = new Vector(records.size());

        // populate the object(s)
        for ( int i=0; i<records.size(); i++ )
        {
            Record row = (Record)records.elementAt(i);
            results.add(WeblogPeer.row2Object(row, 1,
                WeblogPeer.getOMClass()));
        }
        return results;
    }
 

    /** 
     * The class that the Peer will make instances of. 
     * If the BO is abstract then you must implement this method
     * in the BO.
     */
    public static Class getOMClass() 
        throws Exception
    {
            return CLASS_DEFAULT;
        }


    /**
     * Method to do updates. 
     *
     * @param Criteria object containing data that is used to create the UPDATE statement.
     */
    public static void doUpdate(Criteria criteria) throws Exception
    {
            criteria.setDbName(mapBuilder.getDatabaseMap().getName());
            Criteria selectCriteria = new
            Criteria(mapBuilder.getDatabaseMap().getName(), 2);
                                selectCriteria.put( ID, criteria.remove(ID) );
                                                                                                                                                                                        BasePeer.doUpdate( selectCriteria, criteria );
    }

    /** 
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.  It will take care of 
     * the connection details internally. 
     *
     * @param Criteria object containing data that is used to create the UPDATE statement.
     */
    public static void doUpdate(Criteria criteria, DBConnection dbCon) throws Exception
    {
            criteria.setDbName(mapBuilder.getDatabaseMap().getName());
            Criteria selectCriteria = new
            Criteria(mapBuilder.getDatabaseMap().getName(), 2);
                                selectCriteria.put( ID, criteria.remove(ID) );
                                                                                                                                                                                        BasePeer.doUpdate( selectCriteria, criteria, dbCon );
     }

    /** 
     * Method to do deletes.
     *
     * @param Criteria object containing data that is used DELETE from database.
     */
     public static void doDelete(Criteria criteria) throws Exception
     {
            criteria.setDbName(mapBuilder.getDatabaseMap().getName());
                                                                                                                                  BasePeer.doDelete ( criteria );
     }

    /** 
     * Method to do deletes.  This method is to be used during a transaction,
     * otherwise use the doDelete(Criteria) method.  It will take care of 
     * the connection details internally. 
     *
     * @param Criteria object containing data that is used DELETE from database.
     */
     public static void doDelete(Criteria criteria, DBConnection dbCon) throws Exception
     {
            criteria.setDbName(mapBuilder.getDatabaseMap().getName());
                                                                                                                                  BasePeer.doDelete ( criteria, dbCon );
     }

    /** Method to do inserts */
    public static void doInsert( Weblog obj ) throws Exception
    {
                doInsert(buildCriteria(obj));
                obj.setNew(false);
    }

    /**
     * @param obj the data object to update in the database.
     */
    public static void doUpdate(Weblog obj) throws Exception
    {
        doUpdate(buildCriteria(obj));
    }
    /**
     * @param obj the data object to delete in the database.
     */
    public static void doDelete(Weblog obj) throws Exception
    {
        doDelete(buildCriteria(obj));
    }

    /** 
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Weblog) method.  It will take 
     * care of the connection details internally. 
     *
     * @param obj the data object to insert into the database.
     */
    public static void doInsert( Weblog obj, DBConnection dbCon) throws Exception
    {
                doInsert(buildCriteria(obj), dbCon);
                obj.setNew(false);
    }

    /**
     * Method to do update.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Weblog) method.  It will take 
     * care of the connection details internally. 
     *
     * @param obj the data object to update in the database.
     */
    public static void doUpdate(Weblog obj, DBConnection dbCon) throws Exception
    {
        doUpdate(buildCriteria(obj), dbCon);
    }
    /**
     * Method to delete.  This method is to be used during a transaction,
     * otherwise use the doDelete(Weblog) method.  It will take 
     * care of the connection details internally. 
     *
     * @param obj the data object to delete in the database.
     */
    public static void doDelete(Weblog obj, DBConnection dbCon) throws Exception
    {
        doDelete(buildCriteria(obj), dbCon);
    }

    /** Build a Criteria object from the data object for this peer */
    public static Criteria buildCriteria( Weblog obj )
    {
        Criteria criteria = new Criteria();
                                criteria.add( ID, obj.getId() );
                                criteria.add( LOCATION, obj.getLocation() );
                                criteria.add( TITLE, obj.getTitle() );
                                criteria.add( DESCRIPTION, obj.getDescription() );
                                criteria.add( COMMENTS, obj.getComments() );
                                criteria.add( DC_SUBJECT, obj.getDcSubject() );
                                criteria.add( DATE_FOUND, obj.getDateFound() );
                                criteria.add( LAST_UPDATED, obj.getLastUpdated() );
                return criteria;
    }

    /** 
     * Retrieve a single object by pk
     *
     * @param ObjectKey pk
     */
    public static Weblog retrieveByPK( ObjectKey pk )
        throws Exception
    {
        DBConnection db = null;
        Weblog retVal = null;
       try
        {
           db = TurbineDB.getConnection( mapBuilder.getDatabaseMap().getName() );
           retVal = retrieveByPK( pk, db );
        }
        finally
        {
           if (db != null)
              TurbineDB.releaseConnection(db);
        }
        return(retVal);
    }

    /** 
     * Retrieve a single object by pk
     *
     * @param ObjectKey pk
     * @param DBConnection dbcon
     */
    public static Weblog retrieveByPK( ObjectKey pk, DBConnection dbcon )
        throws Exception
    {

        Criteria criteria = new Criteria();
            criteria.add( ID, pk );
        Vector v = doSelect(criteria, dbcon);
        if ( v.size() != 1)
        {
            throw new Exception("Failed to select one and only one row.");
        }
        else
        {
            return (Weblog)v.firstElement();
        }
    }



 

    
 

  


    /** 
     * Returns the TableMap related to this peer.  This method is not 
     * needed for general use but a specific application could have a
     * need.
     */
    protected static TableMap getTableMap()
    {
        return mapBuilder.getDatabaseMap().getTable(TABLE_NAME);
    }     
 

}

