/*
 * ---- 
 *
 * $Id: NewestArticlesSearchRequest.java,v 1.2 2002/02/09 07:31:21 burton Exp $
 * $Project: http://reptile.openprivacy.org $
 * $CVSROOT: :pserver:anoncvs@sierra.openprivacy.org:/usr/local/cvs/public $
 * $WebCVS: http://www.openprivacy.org/cgi-bin/cvsweb/cvsweb.cgi/sierra/ $
 * $Mailing-List: http://www.openprivacy.org/lists/ $
 * $Bugzilla: http://bugzilla.openprivacy.org/ $
 *
 * ----
 *
 * Copyright 2001 OpenPrivacy.org  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the LICENSE which you should have obtaind with this package. 
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.
 */

package org.openprivacy.reptile.search.requests;

import java.io.*;
import java.net.*;
import java.util.*;

import org.openprivacy.reptile.actions.*;
import org.openprivacy.reptile.extensions.*;
import org.openprivacy.reptile.init.*;
import org.openprivacy.reptile.search.*;
import org.openprivacy.reptile.search.impl.*;
import org.openprivacy.reptile.om.*;
import org.openprivacy.reptile.util.*;
import org.openprivacy.reptile.xslt.*;

import org.apache.commons.collections.*;

import org.jdom.*;
import org.jdom.output.*;

/**
 * <p> Finds the newest articles in the system.
 * 
 * @author <a href="mailto:burton@openprivacy.org">Kevin A. Burton</a>
 * @version $Id: NewestArticlesSearchRequest.java,v 1.2 2002/02/09 07:31:21 burton Exp $
 */
public class NewestArticlesSearchRequest extends AdvancedSearchRequest {

    /**
     *  One hour (milliseconds * seconds * minutes )..
     *
     */
    public static final int INTERVAL = 1000 * 60 * 60; 

    /**
     * 
     * Create a new <code>NewestArticlesSearchRequest</code> instance.
     *
     * @author <a href="mailto:burton@openprivacy.org">Kevin A. Burton</a>
     */
    public NewestArticlesSearchRequest() {

        this.getSearchFields().add( ArticlePeer.DATE_FOUND );

        long oldest = System.currentTimeMillis() - INTERVAL;
        
        //compute the time... should be about an hour ago.

        this.setComparator( SearchRequest.GREATER_EQUAL );

        this.addCriteria( new Long( oldest ) );
        
        this.setRequiredSearchProvider( ArticleSearchProvider.class );

    }

}
